<?php
//=================================================================================
//
// File:        inc-lib-modals.php
//
// Description: Librairie de gestion des fenêtes modales
//
//=================================================================================

defined( 'ABSPATH' ) or die( 'No direct script access allowed' );

//----------------------------------------------------------------------------------
// Nom:         boostrap_info_modal()
// Description: Renvoie le code HTML pour afficher un bouton.
//              Ce bouton permet d'ouvrir une siple fenêtre modale  d'information
// Parametres:
//             $button_text   : Texte du bouton
//             $Modal_content : Contenu de la fenêtre modale
// Valeur de retour:
//             Code HTML qu'il faudra afficher.
//----------------------------------------------------------------------------------
function boostrap_info_modal( $button_text, $Modal_content, $button_type = 'button-primary' ) {
	$id = uniqid();
	add_thickbox();
	$to_display = '<div id="'.$id.'" style="display:none;">';
	$to_display .= $Modal_content;
	$to_display .= '</div>';
	$to_display .= '<form style="display:inline-block;"><input alt="#TB_inline?width=800&height=800&inlineId='.$id.'" class="thickbox button '.$button_type.' btn-sm" type="button" value="'.$button_text.'" /></form>';
	return $to_display;
}

//----------------------------------------------------------------------------------
// Nom:	     boostrap_button_link()
// Description: Renvoie le code HTML pour afficher un bouton.
//              Ce bouton permet d'ouvrir une nouvelle page en lien
// Parametres:
//             $button_text   : Texte du bouton
//             $URL           : URL à ouvrir
// Valeur de retour:
//             Code HTML qu'il faudra afficher.
//----------------------------------------------------------------------------------
function boostrap_button_link( $button_text, $URL, $button_type = 'button-primary' ) {
	$id = uniqid();
	$to_display = '<form style="display:inline-block;" action="'.$URL.'" method="get"  target="_blank">';
	$to_display .= '<input class="button '.$button_type.' btn-sm" type="submit" value="'.$button_text.'" name="'.$id.'" id="'.$id.'" />';
	$to_display .= '</form>';
	return $to_display;
}
?>
