<?php
defined( 'ABSPATH' ) or die( 'No direct script access allowed' );

/**
 * Class MonLabo_shortcodes_mother_class
 * Pour être utilisée dans les classes MonLabo_shortcodes et MonLabo_shortcodes_publications
 * @package
 */
class MonLabo_shortcodes_mother_class {

	private static function _item_of_curent_page( $get_item_id_from_wpPostId_method ) {
		$MonLabo_access_data = New MonLabo_access_data();
		$wp_post_id = get_the_ID();
		if ( false != $wp_post_id ) {
			$item_id = $MonLabo_access_data->$get_item_id_from_wpPostId_method( $wp_post_id );
		}
		if ( isset( $item_id ) ) {
			return $item_id;
		} else {
			//Ici on doit refaire un test avec l'url de la page
			$url= MonLaboLib::get_current_url_without_queries();
			$item_id = $MonLabo_access_data->$get_item_id_from_wpPostId_method( $url );
			if ( isset( $item_id ) ) {
				return $item_id;
			} else {
				return '';
			}
		}
	}
	//----------------------------------------------------------------
	//On recherche une éventuelle équipe attachée à la page courrante
	//----------------------------------------------------------------
	protected static function _team_of_curent_page() {
		return self::_item_of_curent_page( 'get_team_id_from_wpPostId' );
	}
	//----------------------------------------------------------------
	//On recherche une éventuelle unité attachée à la page courrante
	//----------------------------------------------------------------
	protected static function _unit_of_curent_page() {
		return self::_item_of_curent_page( 'get_unit_id_from_wpPostId' );
	}

	//------------------------------------------------------------------
	//On recherche une éventuelle personne attachée à la page courrante
	//------------------------------------------------------------------
	protected static function _person_of_curent_page() {
		return self::_item_of_curent_page( 'get_person_id_from_wpPostId' );
	}
}
/**
 * Class MonLabo_shortcodes
 *
 * @package
 */
class MonLabo_shortcodes extends MonLabo_shortcodes_mother_class {

	/*
		_color_of_team_if_only_one_team( $teams )
		_filter_persons_from_belongins( &$teams, &$units, &$categories, $status = 'actif' );

		members_list( $atts )				 DONE
		members_table( $atts )				DONE
		members_chart ()

		perso_panel ()						DONE	TESTED
		team_panel ()						 DONE

		alumni_list ()						DONE
		alumni_table ()
		alumni()

		teams_list ()
		//team_table ()						 POUR FUTUR EVENTUEL
		//thematics_list ()					 POUR FUTUR EVENTUEL
		//unit_list ()						  POUR FUTUR EVENTUEL
		//unit_table ()						 POUR FUTUR EVENTUEL

		dev_team_name()
		dev_team_logo()
	*/

	private static function _color_of_team_if_only_one_team( $teams ) {
		//----------------------------------------------------
		// S'il n'y a qu'une équipe, récupérer sa couleur
		//----------------------------------------------------
		$access_data = New MonLabo_access_data();
		$color = '';
		if ( count( $teams ) === 1 ) {
			$first_team_id = reset( $teams );
			if ( !empty( $first_team_id ) ) {
				$first_team = $access_data->get_team_information( $first_team_id );
				if ( !empty( $first_team ) ) {
					$color = $first_team->color;
				}
			}
		}
		return $color;
	}


	private static function _filter_persons_from_belongins( &$teams, &$units, &$categories, $status = 'actif' ) {
		//-----------------------------------------------------------------------
		// Si au moins une équipe est précisée, filtrer les personnes en fonction des équipes.
		// Sinon filtrer en fonction des unités
		//-----------------------------------------------------------------------
		//  Si teams non vide
		//	  (ignorer units )
		//	  filtrer en fonction de teams
		// sinon
		//	  si units non vide
		//		  filtrer en fonction de units
		//	  sinon (i.e. teams et units sont vides)
		//		  filtrer en fonction de toutes les équipes existantes
		// filtrer en fonction des catégories

		$access_data = New MonLabo_access_data();

		//---------------------------------------
		// 1 - Préparation des variables d'entrée
		//---------------------------------------
		$teams	  = MonLaboLib::prepare_multiple_values_variable_into_array( $teams );
		$units	  = MonLaboLib::prepare_multiple_values_variable_into_array( $units );
		$categories = MonLaboLib::prepare_multiple_values_variable_into_array( $categories );

		//-------------------------------------------
		// 2 - Filtrage en fonction de teams ou units
		//-------------------------------------------
		$direction_title_mode = 'directors';
		$MonLabo_persons = New MonLabo_persons( $access_data->get_persons_information( $status ) );
		//  Si teams non vide
		if ( !empty( $teams ) ) {
			// Préparation de la liste de toutes les équipes existantes
			$existing_teams_id = array_keys( $access_data->get_teams_information() );
			// S'il n'y a qu'une seule équipe, chercher les chefs d'équipe plutot que la direction de la structure.
			if ( count( $teams ) === 1 ){ $direction_title_mode = 'team_leaders';  }
			// Par défaut utiliser toutes les équipes.
			if ( empty( $teams ) ) { $teams = $existing_teams_id;  }
			// On enlève les équipes fantaisistes
			$teams = array_intersect( $teams, $existing_teams_id );
			// On filtre
			$MonLabo_persons->filter_with_teams( $teams, $status );
		} else {
			// Préparation de la liste de toutes les unités existantes
			$existing_units_id = array( MAIN_STRUCT_NO_UNIT=>MAIN_STRUCT_NO_UNIT ) + array_keys( $access_data->get_units_name() );
			// si units non vide
			if ( !empty( $units ) ) {
				// Si l'on demande que la structure principale
				$id_of_units = array_values( $units );
				if ( ( count( $units ) === 1 ) and ( MAIN_STRUCT_NO_UNIT === $id_of_units[0] ) ) {
					// Demander toutes les unités
					$units = $existing_units_id;
				}
				// On enlève les unités fantaisistes
				$units = array_intersect( $units, $existing_units_id );
			} else { //$units et $teams sont vides
				// Demander toutes les unités
				$units = $existing_units_id;
			}
			// On filtre
			$MonLabo_persons->filter_with_units( $units, $status );
		}

		//---------------------------------------
		// 3 - Filtrage en fonction de catégories
		//---------------------------------------
		// Si vide utiliser toutes les catégories existantes (pas la peine de filtrer)
		if ( empty( $categories ) ) {
			$categories = get_MonLabo_persons_categories();
		// Filtrage si non vide
		} else {
			$MonLabo_persons->filter_with_categories( $categories );
		}

		return array( $MonLabo_persons, $direction_title_mode );
	}

	//--------------------------------------------------------------------------------
	// Add shortcode [members_list]
	// get list of persons from teams, labs etc...
	//------------------------------------------------
	// ex 1: [members_list] => get all the persons
	// ex 2: [members_list team = '1'] => get all the persons of team 1, separate leaders
	// ex 3: [members_list team = '1' uniquelist = 'yes'] => get all the persons of team 1
	//													  do not separate leaders
	//--------------------------------------------------------------------------------
	static function members_list( $atts ) {
		$a_afficher = '';
		$access_data = New MonLabo_access_data();
		$generate_HTML = New MonLabo_generate_HTML();
		$currentlang = get_bloginfo( 'language' );

		// normalize attribute keys, lowercase
		$atts = array_change_key_case( (array) $atts, CASE_LOWER );

		// Attributes
		$args = shortcode_atts(
			array(
				'team' => '',
				'unit' => MAIN_STRUCT_NO_UNIT, //structure mère par défaut
				'uniquelist' => 'no',
				'display_direction' => 'yes',
				'categories' => '',
				'person' => '',
			),
			$atts,
			'members_list'
		);

		//Prendre des noms de variable plus adequats pour le traitement
		$units = sanitize_text_field( $args['unit'] );
		$teams = sanitize_text_field( $args['team'] );
		$persons = sanitize_text_field( $args['person'] );

		//Normalize values keys
		$args['categories'] = strtolower( sanitize_text_field( $args['categories'] ) );
		$args['display_direction'] = sanitize_key( $args['display_direction'] );
		$args['uniquelist'] = sanitize_key( $args['uniquelist'] );

		//--------------------------------------------
		// 1 - Sélectionner les personnes
		//--------------------------------------------
		if ( '' == $persons ) {
			//On recherche une éventuelle équipe ou unité attachée à la page courrante
			if ( ( '' === $teams ) ) { $teams = self::_team_of_curent_page(); }
			//On filtre les personnes
			list( $MonLabo_persons, $direction_title_mode )
				= self::_filter_persons_from_belongins( $teams, $units, $args['categories'] );
		} else {
			$MonLabo_persons = New MonLabo_persons( $access_data->get_persons_information( 'actif' ) );
			$persons_ids = MonLaboLib::prepare_multiple_values_variable_into_array( $persons );
			$MonLabo_persons->filter_with_ids( $persons_ids );
			$args['uniquelist'] = 'yes';
		}

		//--------------------------------------------
		// 2 - Générer l'affichage
		//--------------------------------------------
		if ( 'yes' === $args['uniquelist'] ) {
			if ( $MonLabo_persons->count() > 0 ) {
				$a_afficher .= $generate_HTML->persons_list( '', '', $MonLabo_persons->sort_by_name()->get_persons(), $currentlang );
			}
		} else {
			if ( 'yes' === $args['display_direction'] ) {
				if ( 'team_leaders' === $direction_title_mode ) {
					$MonLabo_leaders = $MonLabo_persons->extract_and_suppress_team_leaders();
					if ( $MonLabo_leaders->count()  >0 ) {
						$a_afficher .= $generate_HTML->persons_list(
							MonLabo_translate::translate( 'Team leader', $currentlang ),
							MonLabo_translate::translate( 'Team leaders', $currentlang ),
							$MonLabo_leaders->sort_by_name()->get_persons(),
							$currentlang
						);
					}
				} else {
					$MonLabo_directors = $MonLabo_persons->extract_and_suppress_direction();
					if ( $MonLabo_directors->count() >0 ) {
						$a_afficher .= $generate_HTML->persons_list(
							MonLabo_translate::translate( 'Direction', $currentlang ),
							MonLabo_translate::translate( 'Direction', $currentlang ),
							$MonLabo_directors->sort_by_name()->get_persons(),
							$currentlang
						);
					}
				}
			}
			if ( 'team_leaders' === $direction_title_mode ) {
				//On est dans une équipe, afficher tous les non leaders ensemble.
				if ( $MonLabo_persons->count() >0 ) {
					$a_afficher .= $generate_HTML->persons_list(
						MonLabo_translate::translate( 'Member', $currentlang ),
						MonLabo_translate::translate( 'Members', $currentlang ),
						$MonLabo_persons->sort_by_name()->get_persons(),
						$currentlang
					);
				}
			} else {
				//On est dans une unité, séparer par catégories
				foreach ( $args['categories'] as $key => $category ) {
					$MonLabo_persons_for_one_category= New MonLabo_persons( $MonLabo_persons->get_persons() );
					$MonLabo_persons_for_one_category->filter_with_categories( array( "$category" ) );
					if ( $MonLabo_persons->count() >0 ) {
						$a_afficher .= $generate_HTML->persons_list(
							$category,
							$category,
							$MonLabo_persons_for_one_category->sort_by_name()->get_persons(),
							$currentlang
						);
					}
				}
			}
		}
		return $a_afficher;
	}

	//--------------------------------------------------------------------------------
	// Add shortcode [members_table]
	// get table of persons from teams, labs etc...
	//------------------------------------------------
	// ex 1: [members_table] => get all the persons
	// ex 2: [members_table team = '1'] => get all the persons of team 1
	//--------------------------------------------------------------------------------
	static function members_table( $atts ) {
		$a_afficher = '';

		$access_data = New MonLabo_access_data();
		$generate_HTML = New MonLabo_generate_HTML();
		$currentlang = get_bloginfo( 'language' );

		// normalize attribute keys, lowercase
		$atts = array_change_key_case( (array ) $atts, CASE_LOWER );

		// Attributes
		$args = shortcode_atts(
				array(
				'team' => '',
				'unit' => MAIN_STRUCT_NO_UNIT, //structure mère par défaut
				'presentation' => 'normal',
				'uniquelist' => 'no',
				'display_direction' => 'yes',
				'categories' => ''
			),
			$atts,
			'members_table'
		);
		//Prendre des noms de variable plus adequats pour le traitement
		$units = sanitize_text_field( $args['unit'] );
		$teams = sanitize_text_field( $args['team'] );

		//Normalize values keys
		$args['categories'] = sanitize_text_field( strtolower( $args['categories'] ) );
		$args['display_direction'] = sanitize_key( $args['display_direction'] );
		$args['uniquelist'] = sanitize_key( $args['uniquelist'] );
		$args['presentation'] = sanitize_key( $args['presentation'] );

		//--------------------------------------------
		// 1 - Sélectionner les personnes
		//--------------------------------------------

		//On recherche une éventuelle équipe attachée à la page courrante
		if ( '' === $teams ) { $teams = self::_team_of_curent_page(); }

		list( $MonLabo_persons, $direction_title_mode ) =
			self::_filter_persons_from_belongins( $teams, $units, $args['categories'] );

		//----------------------------------------------------
		// 2 - S'il n'y a qu'une équipe, récupérer sa couleur
		//----------------------------------------------------
		$color = self::_color_of_team_if_only_one_team( $teams );

		//--------------------------------------------
		// 3 - Générer l'affichage
		//--------------------------------------------
		$MonLabo_directors = New MonLabo_persons();
		if ( ( 'yes' === $args['display_direction'] ) and ( 'yes' != $args['uniquelist'] ) ) {
			//Ajoute une catégorie 'direction'
			$MonLabo_directors = $MonLabo_persons->extract_and_suppress_direction();
		}

		if ( 'compact' === $args['presentation'] ) {
			$person_array = array();
			foreach ( $args['categories'] as $key => $category ) {
				$MonLabo_persons_for_one_category = New MonLabo_persons( $MonLabo_persons->get_persons() );
				$MonLabo_persons_for_one_category->filter_with_categories( array( "$category" ) );
				if ( $MonLabo_directors->count() >0 ) {
					$person_array['direction'] = $generate_HTML->persons_table_compact_column(
						$MonLabo_directors->sort_by_name()->get_persons(),
						MonLabo_translate::translate( 'Direction', $currentlang ),
						$currentlang,
						$color
					);
				}
				if ( $MonLabo_persons_for_one_category->count() >0 ) {
					$person_array[$category] = $generate_HTML->persons_table_compact_column(
						$MonLabo_persons_for_one_category->sort_by_name()->get_persons(),
						ucfirst( $category ),
						$currentlang,
						$color
					);
				}
			}
			//$person_array has to be 2 dimensions.
			if ( count( $person_array ) >0 ) {
				$a_afficher .= $generate_HTML->generic_table( '', '', array( $person_array ), "", "", "MonLabo-persons-table-compact" );
			}
		} else {
			//Affichage du mode normal ( annuaire )
			$colum_titles = array( 'Nom', 'Equipe', 'Email', 'Tel' );
			if ( 'yes' != $args['uniquelist'] ) {
				if ( $MonLabo_directors->count() >0 ) {
					$a_afficher .=$generate_HTML->persons_table_normal(
						MonLabo_translate::translate( 'Direction', $currentlang ),
						$colum_titles,
						$MonLabo_directors->sort_by_name()->get_persons(),
						$currentlang,
						$color
					);
				}
				foreach ( $args['categories'] as $key => $category ) {
					$MonLabo_persons_for_one_category= New MonLabo_persons( $MonLabo_persons->get_persons() );
					$MonLabo_persons_for_one_category->filter_with_categories( array( "$category" ) );
					if ( $MonLabo_persons_for_one_category->count() >0 ) {
						$a_afficher .=$generate_HTML->persons_table_normal(
							ucfirst( $category ),
							$colum_titles,
							$MonLabo_persons_for_one_category->sort_by_name()->get_persons(),
							$currentlang,
							$color
						);
					}
				}
			} else { //$args['uniquelist'] === 'yes'
				if ( $MonLabo_persons->count() >0 ) {
					$a_afficher .=$generate_HTML->persons_table_normal(
						'',
						$colum_titles,
						$MonLabo_persons->sort_by_name()->get_persons(),
						$currentlang,
						$color
					);
				}
			}
		}

		return $a_afficher;
	}

	//--------------------------------------------------------------------------------
	// Add shortcode [members_chart]
	// get organizational chart of persons from teams, labs etc...
	//------------------------------------------------
	// ex 1: [members_chart] => get all the persons
	//--------------------------------------------------------------------------------
	static function members_chart( $atts ) {
		return self::persons_chart( $atts, 'actif' , 'members_chart' );
	}

	//--------------------------------------------------------------------------------
	// Add shortcode [alumni_chart]
	// get organizational chart of alumni from teams, labs etc...
	//------------------------------------------------
	// ex 1: [alumni_chart] => get all the alumni
	//--------------------------------------------------------------------------------
	static function alumni_chart( $atts ) {
		return self::persons_chart( $atts, 'alumni', 'alumni_chart' );
	}

	static function persons_chart( $atts, $status = 'actif', $shortcode_name = 'members_chart' ) {
		//TODO: Mettre en place les couleurs des équipes à partir de la version 1.00 de la base de données
		$a_afficher = '';
		$access_data = New MonLabo_access_data();
		$generate_HTML = New MonLabo_generate_HTML();
		$persons_information_by_category_and_team = array();
		$currentlang = get_bloginfo( 'language' );

		// normalize attribute keys, lowercase
		$atts = array_change_key_case( (array ) $atts, CASE_LOWER );

		// Attributes
		$args = shortcode_atts(
				array(
				'unit' => '',
				'team' => '',
				'display_direction' => 'yes',
				'categories' => '',
				'years' => '', /*Pour les alumni */
				'year' => '',
				'annee' => '',
			),
			$atts,
			$shortcode_name
			);

		//Normalize values keys
		$args['categories'] = sanitize_text_field( strtolower( $args['categories'] ) );
		$args['display_direction'] = sanitize_key( $args['display_direction'] );

		//-----------------------------------------------------------------------
		// Tenter de déterminer le contexte. Par défaut concaténer les équipes courantes
		//-----------------------------------------------------------------------
		// Si ni unité ni équipe n'est demandée, regarder si la page en cours n'en
		// précise pas par défaut. Sinon, prendre toutes les unités + la structure
		// principale.
		//-----------------------------------------------------------------------
		//  Si units et teams sont vides
		//	  Si unite(page en cours )  existe  ==>  units = unite(page en cours )
		//	  Si equipe(page en cours ) existe  ==>  teams = equipe(page en cours )
		//	  sinon
		//		  units = { ensemble des unites}+structure principale

		//-----------------------------------------------------------------------
		// On prend la direction de la structure principale si elle est demandée
		// si celle ci-est vide, alors on concatène la direction de l'ensemble
		// des unites demandée
		//-----------------------------------------------------------------------
		//  Si teams non vide
		//	  directeurs = vide  //Cela n'a pas de sens d'afficher des directeurs
		//  sinon
		//	  Si units comprend la structure principale
		//		  directeurs = directeurs(structure principale )
		//		  si directeurs est vide
		//			  directeurs = directeurs{units}
		//	  sinon
		//		  directeurs = directeurs{units}

		//-----------------------------------------------------------------------
		// On prend le nom de la structure principale si elle est demandée
		// sinon, et s'il n'y a qu'une unité demandée, on prend son nom.
		//-----------------------------------------------------------------------
		//  Si teams non vide
		//	  nom de la structure = vide
		//  sinon
		//	  Si units comprend la structure principale
		//		  nom de la structure = structure principale
		//	  sinon
		//		  nom de la structure = vide ou nom de l'unité s'il n'y en a qu'une



		// Prendre des noms de variable plus adequats pour le traitement
		$units = sanitize_text_field( $args['unit'] );
		$teams = sanitize_text_field( $args['team'] );

		// Pouvoir utiliser le paramètre years au sigulier au besoin
		if ( '' === $args['years'] )   { $args['years'] = $args['year'];	 }
		// Par defaut years remplace annee sauf si years est vide
		if ( '' === $args['years'] )   { $args['years'] = $args['annee'];	 }
		$args['years'] = sanitize_text_field( $args['years'] );

		//--------------------------------------------
		// 1 - Sélectionner les personnes
		//--------------------------------------------
		if ( ( '' === $teams ) and ( '' === $units ) ) {

			// On recherche une éventuelle équipe attachée à la page courante
			$teams = self::_team_of_curent_page();
			if ( '' === $teams ) {
				$units = MAIN_STRUCT_NO_UNIT.','.implode( ',', array_keys( $access_data->get_units_name() ) );
			}
		}

		//Cela met à jour la liste des équipes, unités...
		list( $MonLabo_persons, $direction_title_mode ) = self::_filter_persons_from_belongins( $teams, $units, $args['categories'], $status );

		//--------------------------------------------
		// 3 - Determiner le nom de l'unité à afficher
		//---------------------------------------------
		$unit_name ='';
		if ( ( empty( $teams ) ) and ( in_array( MAIN_STRUCT_NO_UNIT, $units ) ) ) {
			$options = get_option( 'MonLabo_settings_group1' );
			$unit_name = $options['MonLabo_nom'].'  -  '.$options['MonLabo_code'];
		} elseif ( ( empty( $teams ) ) and ( count( $units ) === 1 ) ) {
			$unit_ids = array_values( $units );
			$unit_id = $unit_ids[0];
			$unit_information = $access_data->get_unit_information( $unit_id );
			$unit_name =
				$access_data->get_unit_name( $unit_id, $currentlang )
				.'  -  '
				.$unit_information->code;
		} else {
			$unit_name = '';
		}

		//--------------------------------------------
		// 4 - Determiner les directeurs à afficher
		//---------------------------------------------
		$directors = array();
		if ( 'alumni' != $status ) {
			if ( ( empty( $teams ) ) and ( 'yes' === $args['display_direction'] ) ) {
				if ( in_array( MAIN_STRUCT_NO_UNIT, $units ) ) {
					$directors = $access_data->get_directors_information_for_an_unit( MAIN_STRUCT_NO_UNIT );
				}
				if ( empty( $directors ) ) {
					$directors = array();
					if ( !empty( $units ) ) {
						foreach ( $units as $one_unit ) {
							$directors_for_one_unit = $access_data->get_directors_information_for_an_unit(
								$one_unit
							);
							if ( empty( $directors_for_one_unit ) ) { $directors_for_one_unit = array(); }
							$directors = $directors + $directors_for_one_unit;
						}
					}
				}
			}
		}
		$MonLabo_directors = New MonLabo_persons( $directors );

		//--------------------------------------------
		// 5 - Prendre toutes les équipes des unités indiquées si aucune équipe précisée
		//---------------------------------------------
		$teams_information = array();
		$all_teams_information = $access_data->get_teams_information();

		if ( ( empty( $teams ) ) and ( !empty( $units ) ) ) {
			foreach ( $units as $unit_id ) {
				$teams_for_unit = $access_data->get_teams_id_for_an_unit( $unit_id );
				if ( NULL === $teams_for_unit ) { $teams_for_unit = Array(); }
				$teams = $teams + $teams_for_unit;
			}
		}
		foreach ( $teams as $team_id ) {
			if ( array_key_exists( $team_id, $all_teams_information ) ) {
				$teams_information[$team_id] = $all_teams_information[$team_id];
			}
		}

		//--------------------------------------------
		// 6 - Générer l'affichage
		//--------------------------------------------
		foreach ( $args['categories'] as $category ) {
			foreach ( $teams as $team_id ) {
				$persons_information = $access_data->get_persons_information_for_a_category_in_a_team(
					$category,
					$team_id,
					$status
				);
				$MonLabo_persons = New MonLabo_persons( $persons_information );
				$MonLabo_persons->suppress_non_visible();

				// Les filtrer selon la date si l'on est en mode alumni
				if ( 'alumni_chart' === $shortcode_name ) {
					if ( !empty( $args['years'] ) ) {
						if ( !empty( $persons_information ) ) {
							$MonLabo_persons->filter_with_alumni_years( $args['years'] );
						}
					}
				}
				$persons_information = $MonLabo_persons->get_persons();
				$team_leaders_id = $access_data->get_leaders_id_for_a_team( $team_id );

				// On tague les leaders de chaque équipe
				if ( !empty( $persons_information ) ) {
					foreach ( $persons_information as $id => $person ) {
						$person = (array) $person;
						if ( ( !empty( $team_leaders_id ) ) and ( in_array( $id, $team_leaders_id) ) ) {
							$person['leader'] = true;
						} else {
							$person['leader'] = false;
						}
						$persons_information[$id] = (object ) $person;
					}
					$persons_information_by_category_and_team[$category][$team_id] = $persons_information;
				}
			}

		}
		$a_afficher .= $generate_HTML->persons_chart(
			$unit_name,
			$MonLabo_directors->get_persons(),
			$teams_information,
			$persons_information_by_category_and_team,
			$currentlang
		);

		return $a_afficher;
	}

	//--------------------------------------------------------------------------------
	// Add shortcode [perso_panel]
	// Generate the personnal panel of the user belonging to the current page
	// Ex: [perso_panel] => Only way to use ( no parameters )
	//--------------------------------------------------------------------------------
	static function perso_panel( $atts ) {
		$generate_HTML = New MonLabo_generate_HTML();
		$access_data = New MonLabo_access_data();

		// normalize attribute keys, lowercase
		$atts = array_change_key_case( (array) $atts, CASE_LOWER );
		// Attributes
		$args = shortcode_atts(
			array(
				'person' => '',
			),
			$atts,
			'perso_panel'
		);
		if ( '' == $args['person'] ) {
			$person_id = self::_person_of_curent_page();;
		} else {
			$person_id = intval( $args['person'] );
		}

		//var_dump( $person_id );
		if ( !empty( $person_id ) ) {
			$person_information = $access_data->get_person_information( $person_id );
			if ( !empty( $person_information ) ) {
				$mentors_information= $access_data->get_mentors_information_for_a_person( $person_id );
				$students_information = $access_data->get_students_information_for_a_person( $person_id );
				$currentlang = get_bloginfo( 'language' );
				return $generate_HTML->person_panel(
					$person_information,
					$mentors_information,
					$students_information,
					$currentlang
				);
			}
		}
		return '';
	}

	//--------------------------------------------------------------------------------
	// Add shortcode [team_panel]
	// Generate the team panel of the team belonging to the current page
	// Ex: [team_panel] => Only way to use (no parameters)
	//--------------------------------------------------------------------------------
	static function team_panel( $atts ) {
		$generate_HTML = New MonLabo_generate_HTML();
		$access_data = New MonLabo_access_data();

		// normalize attribute keys, lowercase
		$atts = array_change_key_case( (array) $atts, CASE_LOWER );

		// Attributes
		$args = shortcode_atts(
			array(
				'team' => '',
			),
			$atts,
			'team_panel'
		);

		if ( '' == $args['team'] ) {
			$team_id = self::_team_of_curent_page();;
		} else {
			$team_id = intval( $args['team'] );
		}

		if ( !empty( $team_id ) ) {
			$team_information = $access_data->get_team_information( $team_id );
			if ( !empty( $team_information ) ) {
				$leaders_information = $access_data->get_leaders_information_for_a_team( $team_id );
				$currentlang = get_bloginfo( 'language' );
				$thematics_name = $access_data->get_thematics_name_for_a_team( $team_id, $currentlang );
				return $generate_HTML->team_panel(
					$team_information,
					$leaders_information,
					$thematics_name,
					$currentlang
				);
			}
		}
		return '';
	}

	//--------------------------------------------------------------------------------
	// Add shortcode [alumni_list]
	// get list of old members from teams, labs etc...
	//------------------------------------------------
	// ex : [alumni_list title = 'Former PhDs and Postdocs' categories = 'postdocs,students'] => get all the alumni was PhD or PostDoct Members and print with title caption
	//--------------------------------------------------------------------------------
	static function alumni_list( $atts ) {
		$a_afficher = '';
		$generate_HTML = New MonLabo_generate_HTML();
		$currentlang = get_bloginfo( 'language' );

		// normalize attribute keys, lowercase
		$atts = array_change_key_case( (array) $atts, CASE_LOWER );
		// Attributes
		$args = shortcode_atts(
			array(
				'team' => '',
				'unit' => MAIN_STRUCT_NO_UNIT, //structure mère par défaut
				'title' => '',
				'categories' => '',
				'years' => '',
				'year' => '',
				'annee' => '',
				'external_link_title' => '',
			),
			$atts,
			'alumni_list'
		);
		//Prendre des noms de variable plus adequats pour le traitement
		$units = sanitize_text_field( $args['unit'] );
		$teams = sanitize_text_field( $args['team'] );

		// Pouvoir utiliser le paramètre years au sigulier au besoin
		if ( '' === $args['years'] )   { $args['years'] = $args['year'];	 }
		// Par defaut years remplace annee sauf si years est vide
		if ( '' === $args['years'] )   { $args['years'] = $args['annee'];	 }
		$args['years'] = sanitize_text_field( $args['years'] );

		// Normalize values keys
		$args['categories'] = strtolower( sanitize_text_field( $args['categories'] ) );
		$args['title'] = sanitize_text_field( $args['title'] );
		$args['external_link_title'] = esc_url( $args['external_link_title'] );

		//--------------------------------------------
		// 1 - Sélectionner les personnes
		//--------------------------------------------
		// On recherche une éventuelle équipe attachée à la page courrante
		if ( '' === $teams ) { $teams = self::_team_of_curent_page(); }

		list( $MonLabo_persons, $dummy ) = self::_filter_persons_from_belongins(
			$teams,
			$units,
			$args['categories'],
			'alumni'
		);

		//--------------------------------------------
		// 2 - Les filtrer selon la date
		//--------------------------------------------
		if ( !empty( $args['years'] ) ) {
			$MonLabo_persons->filter_with_alumni_years( $args['years'] );
		}

		//--------------------------------------------
		// 3 - Générer l'affichage
		//--------------------------------------------
		if ( $MonLabo_persons->count() >0 ) {
			//2 - Lance l'affichage
			$MonLabo_persons->sort_by_name();
			$a_afficher .= $generate_HTML->persons_list(
				$args['title'],
				$args['title'],
				$MonLabo_persons->get_persons(),
				$currentlang
			);
		}
		return $a_afficher;
	}

	//--------------------------------------------------------------------------------
	// Add shortcode [alumni_table]
	// get list of old members from teams, labs etc...
	//------------------------------------------------
	// ex: [alumni_table title = 'Former PhDs and Postdocs' categories = 'postdocs,students'] => get all the alumni was PhD or PostDoct Members and print with title caption
	//--------------------------------------------------------------------------------
	static function alumni_table( $atts ) {
		$a_afficher = '';
		$access_data = New MonLabo_access_data();
		$generate_HTML = New MonLabo_generate_HTML();
		$currentlang = get_bloginfo( 'language' );

		// normalize attribute keys, lowercase
		$atts = array_change_key_case( ( array) $atts, CASE_LOWER );

		// Attributes
		$args = shortcode_atts(
			array(
				'team' => '',
				'unit' => MAIN_STRUCT_NO_UNIT, //structure mère par défaut
				'title' => '',
				'categories' => '',
				'years' => '',
				'year' => '',
				'annee' => '',
			),
			$atts,
			'alumni_table'
		);

		// Prendre des noms de variable plus adequats pour le traitement
		$units = sanitize_text_field( $args['unit'] );
		$teams = sanitize_text_field( $args['team'] );

		// Pouvoir utiliser le paramètre years au sigulier au besoin
		if ( '' === $args['years'] )   { $args['years'] = $args['year'];	  }
		//Par defaut years remplace annee sauf si years est vide
		if ( '' === $args['years'] )   { $args['years'] = $args['annee'];	 }
		$args['years'] = sanitize_text_field( $args['years'] );

		// Normalize values keys
		$args['categories'] = sanitize_text_field( strtolower( $args['categories'] ) );

		//--------------------------------------------
		// 1 - Sélectionner les personnes
		//--------------------------------------------
		// On recherche une éventuelle équipe attachée à la page courrante
		if ( '' === $teams ) { $teams = self::_team_of_curent_page(); }

		list( $MonLabo_persons, $dummy ) = self::_filter_persons_from_belongins(
			$teams,
			$units,
			$args['categories'],
			'alumni'
		);

		//--------------------------------------------
		// 2 - Les filtrer selon la date
		//--------------------------------------------
		if ( !empty( $args['years'] ) ) {
			$MonLabo_persons->filter_with_alumni_years( $args['years'] );
		}

		//----------------------------------------------------
		// 3 - S'il n'y a qu'une équipe, récupérer sa couleur
		//----------------------------------------------------
		$color = self::_color_of_team_if_only_one_team( $teams );

		//--------------------------------------------
		// 4 - Générer l'affichage
		//--------------------------------------------
		//Affichage du mode normal ( annuaire )
		$colum_titles = array( 'Nom', 'Equipe', 'Email', 'Tel' );
		if ( $MonLabo_persons->count() >0 ) {
			$a_afficher .=$generate_HTML->persons_table_normal(
				$args['title'],
				$colum_titles,
				$MonLabo_persons->sort_by_name()->get_persons(),
				$currentlang,
				$color,
				'alumni'
			);
		}
		return $a_afficher;
	}

	//--------------------------------------------------------------------------------
	/**
	 * Add shortcode [alumni]
	 * Affiche un ancien membre
	 * Ex: [alumni firstname = 'Annie' name = 'Malduzoo' text = 'Ancien membre de renom (2015 )']
	 * @param array $atts
	 * @return string
	 */
	 //--------------------------------------------------------------------------------
	 static function alumni( $atts ) {
		$generate_HTML = New MonLabo_generate_HTML();
		$currentlang = get_bloginfo( 'language' );

		// normalize attribute keys, lowercase
		$atts = array_change_key_case( (array) $atts, CASE_LOWER );

		// Get the parameters and set default values
		//------------------------------------------
		$args = shortcode_atts(
			array(
				'firstname' => NULL,
				'name' => NULL,
				'picture' => '',
				'text' => NULL,
				//'mail' => '', //optional
				'link' => '',
				'door' => '',
				'teams' => '',
				'phone' => '',
				'external_link' => '',
			),
			$atts,
			'alumni'
		);

		$person_information = (object) array(
			'first_name'	=> sanitize_text_field($args['firstname']),
			'last_name'		=> sanitize_text_field($args['name']),
			'room'			=> sanitize_text_field($args['door']),
			'phone'			=> sanitize_text_field($args['phone']),
			'address_alt'	=> esc_url( $args['external_link'] ),
			'function_en'	=> '<br />' . sanitize_text_field($args['text']),
			'function_fr'	=> '<br />' . sanitize_text_field($args['text'])
		);
		return '<div class="MonLabo MonLabo-persons-list"><ul><li>'
				. $generate_HTML->generate_HTML_person_small_panel(
					$person_information,
					$currentlang,
					$args['picture']
				)
				. '</li><ul></div>';
	}

	/*private static function _filter_teams_from_belongins( &$groups, &$units ) {
		//-----------------------------------------------------------------------
		// Filtrer les équipes en fonction des groupes et des unités.
		//-----------------------------------------------------------------------

		$access_data = New MonLabo_access_data();

		//---------------------------------------
		// 1 - Préparation des variables d'entrée
		//---------------------------------------
		$groups = MonLaboLib::prepare_multiple_values_variable_into_array( $groups );
		$units  = MonLaboLib::prepare_multiple_values_variable_into_array( $units );

		//-------------------------------------------
		// 2 - Filtrage en fonction des groupes
		//-------------------------------------------
		if ( empty( $groups ) ) {
			$MonLabo_persons->filter_with_units( $groups );
		}

		//---------------------------------------
		// 3 - Filtrage en fonction des unités
		//---------------------------------------
		if ( empty( $units ) ) {
			$MonLabo_persons->filter_with_units( $units );
		}

		return array( $MonLabo_persons, $direction_title_mode );
	}*/


	//--------------------------------------------------------------------------------
	// Add shortcode [teams_list]
	// get list of teams
	//------------------------------------------------
	// ex: [teams_list thematic = "3"] => Get the list of teams for thematics 3
	//--------------------------------------------------------------------------------
	static function teams_list( $atts ) {
		$a_afficher = "";
		$access_data = New MonLabo_access_data();
		$generate_HTML = New MonLabo_generate_HTML();
		$currentlang = get_bloginfo( 'language' );

		// normalize attribute keys, lowercase
		$atts = array_change_key_case( (array) $atts, CASE_LOWER );

		// Attributes
		$args = shortcode_atts(
			array(
				'thematic' => "",
				'unit' => "",
				'group' => "",
				'teams_publications_page' => ""
			),
			$atts,
			'teams_list'
		);

		$args['unit'] = sanitize_text_field( $args['unit'] );
		$args['thematic'] = sanitize_text_field( $args['thematic'] );
		$args['group'] = sanitize_text_field( $args['group'] );
		$args['teams_publications_page'] = esc_url( $args['teams_publications_page'] );


		if ( !( '' === $args['thematic'] ) ) {
			$args['group'] = $args['thematic'];
		}
		if ( !( '' === $args['group'] ) ) {
			$teams_information = $access_data->get_teams_information_for_a_thematic( $args['group'] );
		} else {
			$teams_information = $access_data->get_teams_information();
		}
		$groups_information = array();
		$teams_leaders = array();
		if ( is_array( $teams_information ) ) {
			foreach ( $teams_information as $key=>$team_information ) {
				$groups_information[$team_information->id] = $access_data->get_thematics_information_for_a_team( $team_information->id );
				$teams_leaders[$team_information->id] = $access_data->get_leaders_name_for_a_team( $team_information->id );

				//Si pas de logo définit, utiliser celui de l'unité
				if ( empty( $team_information->logo ) ) {
					if ( isset( $team_information->id_unit ) ) {
						$unit_information = $access_data->get_unit_information( $team_information->id_unit );
						if ( ( !empty( $unit_information ) ) and ( isset( $unit_information->logo ) ) ) {
							$teams_information[$key]->logo = $unit_information->logo;
						}
					}
				}
			}
		}
		$a_afficher .= $generate_HTML->teams_list(
			$args['group'],
			$teams_information,
			$teams_leaders,
			$groups_information,
			$args['teams_publications_page'],
			$currentlang
		);

		return $a_afficher;
	}

	//--------------------------------------------------------------------------------
	// Add shortcode [dev_team_name]
	// get team name from Descartes Pubbmed id for developpers...
	// This function is not public and documented, only for developping purpose
	//------------------------------------------------
	// ex 1: [dev_team_name descartes_publi_team_id = "3"] => get the english name of team 3
	//--------------------------------------------------------------------------------
	static function dev_team_name( $atts ) {

		// normalize attribute keys, lowercase
		$atts = array_change_key_case( (array) $atts, CASE_LOWER );

		// Attributes
		$args = shortcode_atts(
				array(
				'descartes_publi_team_id' => '',
			),
			$atts,
			'dev_team_name'
		);

		$args['descartes_publi_team_id'] = sanitize_text_field( $args['descartes_publi_team_id'] );

		global $wpdb;
		$team = $wpdb->get_results(
			$wpdb->prepare( "SELECT `name_en` FROM MonLabo_teams  WHERE `descartes_publi_team_id` = %s", $args['descartes_publi_team_id']),
			ARRAY_A
		);
		if ( ( isset( $team[0] ) ) and isset( $team[0]["name_en"] ) ) {
			return $team[0]["name_en"];
		}
		return "";
	}
	//--------------------------------------------------------------------------------
	// Add shortcode [dev_team_logo]
	// get team logo from Descartes Pubbmed id for developpers...
	// This function is not public and documented, only for developping purpose
	//------------------------------------------------
	// ex 1: [dev_team_logo descartes_publi_team_id = "3"] => get the logo of team 3
	//--------------------------------------------------------------------------------
	static function dev_team_logo( $atts ) {

		// normalize attribute keys, lowercase
		$atts = array_change_key_case( (array) $atts, CASE_LOWER );

		// Attributes
		$args = shortcode_atts(
				array(
				'descartes_publi_team_id' => '',
			),
			$atts,
			'dev_team_logo'
		);

		$args['descartes_publi_team_id'] = sanitize_text_field( $args['descartes_publi_team_id'] );

		global $wpdb;
		$team = $wpdb->get_results(
			$wpdb->prepare( "SELECT `logo` FROM MonLabo_teams  WHERE `descartes_publi_team_id` = %s", $args['descartes_publi_team_id']),
			ARRAY_A
		);
		if ( ( isset( $team[0] ) ) and isset( $team[0]["logo"] ) ) {
			return $team[0]["logo"];
		}
		return "";
	}
}
